<?php

abstract class Classifier
{
    protected $posLabel = -1;
    protected $negLabel = -1;

    public function __construct($params = array())
    {
        foreach ($params as $param => $val) {
            if (property_exists($this, $param)) {
                $this->$param = $val;
            }
        }
    }

    abstract public function train($X, $y, $labels);
    abstract public function classify($x);

    protected function handleBinaryLabels(&$labels)
    {
        if (count($labels) != 2)
            return;

        if ($this->posLabel != -1) {
            $rm = ($labels[0] == $this->posLabel) ? 1 : 0;
            $this->negLabel = $labels[1 - $rm];
            unset($labels[$labels[$rm]]);
        } else {
            $this->posLabel = $labels[0];
            $this->negLabel = $labels[1];
            unset($labels[$labels[1]]);
        }
    }
}
